# Imports
import json # to work with .json files  (.json-->.csv)
import pandas as pd # to convert files
import wget # to download the data at links
import gzip # (json.gz-->.json) ^ (.json-->.csv)
import shutil # (json.gz-->.json) ^ (.json-->.csv)
import os # to extract and convert files from the dir
import urllib.request # to check the size of the file
import sys
import time


def get_links(file_name):
    """
    A function to take the index.json file, extract all the location(links)
    then filter out the donwloadable .json.gz links and store them in a list then write them to a .txt file
    At the end call the download function with the filtered list of links
    :param file_name: json file
    :return: run download function to get the files at the links
    """
    print(f"Entering get_links({file_name}) function\n")
    links_to_check = []
    links_to_download=[]
    with open(file_name,'r') as f:
        links_to_check=f.readlines()
    print(f"links_to_check list = {links_to_check}\n]\n")
    for i in range(len(links_to_check)-1):
        if links_to_check[i].endswith(".json\n"):
            links_to_download.append(links_to_check[i][:-1])
        else:
            print(f"Its a json.gz link so ignore.\n link = {links_to_check[i]}")
           
    print(f"\n\nDone with get_links() function and moving to download() function\n")
    print(links_to_download)
    return download(links_to_download)


def download(links_to_download):
    """
    A function which takes the link from the list, go the url
    check the file size,
    if the size is allowed to be downloaded then downloads it
    else ignores it.

    :param links_to_download: a list with .json.gz links
    :return: run the unzip_extract_convert function
    """
    print(f"\nEentering download function with download({links_to_download})\n")
    # Downloading the files at the given links using wget command
    for url in links_to_download:
        #url=links_to_download[25]
        try:
            # checking for larger files to ignore
            file = urllib.request.urlopen(url)
            print(f"Getting data at {url} having {file.length / 1e6} MBs\n")
            if file.length < 2e8:  # only checking for 200 MBs 2e+8 bytes #TODO: Set the file size
                wget.download(url, out='./json/')
                print(f"\nDOWNLOADED\n{url}\n")
                print(f"\nDone with download() and moving to unzip_extract()\n")
                unzip_extract()
                print("One file done\nEXTING...")
                #break # checking for one file
            else:
                print(f"The file size is {file.length / 1e6} MBs which is greater then 200 MBs... IGNORING\n")
        except:
            print("Invalid Link. No Downloadble File  found")

           
def unzip_extract():
    print(f"Entering unzip_extract() function\n")
    # Unzip the .json.gz
    path_of_the_directory = './json/'
    ext1 = ('.gz')
    for files in os.listdir(path_of_the_directory):
        files="./json/"+files
        if files.endswith(ext1):
            # name = files[2:-3]
            # # print(files) 
            # # Extracting json.gz to .json and then converting .json to .csv and saving with the name
            # with gzip.open(files, 'rb') as f_in:
            #     print("EXTRACTING...")
            #     with open("./json/"+name, 'wb') as f_out:
            #         shutil.copyfileobj(f_in, f_out)
            #         json_file=pd.read_json("./json/"+name)                 
            #         json_file.to_csv("./json/csv/"+name[:-4]+'csv')
            #         print(f"\nDone with CONVERTING the file \n{name} \n\t\t\t\t to \n{name[:-4]}csv\n")
            #         print(f"Deleting the file done\nDELETING...")
            #         os.remove(json_file)
            os.remove(files)
        else:
            print(f"File {files} is in .json format.")
    print(f"Done with unzip_extract() function \n\t\t\tTHE SCRIPT IS DONE\n--------------------------------------\n\n")



if __name__ == "__main__":
    print(f"Run from command line as:\n"
          f"python3 main.py 'filename'")
    if sys.argv[1] and sys.argv[1][-4:]==".txt":
        file_name=sys.argv[1]
        get_links(sys.argv[1])
    else:
        print("WRONG inputs")
        print("Try using python3 main.py 'filename'\nYour file extension should be .txt and the file should be in the same directory")
