import pandas as pd
import json
import os

def convert_json_to_csv(file):
    print(f"\n===================================================\nConverting the file\n{file}")
    # Opening with pandas to check the json file
    json_file = pd.read_json(file)
    new_json_file = json_file.iloc[:,:4]
    # FINAL columns with correct naming and valus
    negotiation_arrangements=[]
    names=[]
    billing_code_types=[]
    billing_code_type_versions=[]
    billing_codes=[]
    descriptions=[]
    negotiated_rates=[]
    # service_codes=[]
    expiration_dates=[]
    negotiated_types=[]
    billing_classes=[]
    # billing_code_modifiers=[]
    # additional_informations=[]
    # npis=[]
    tin_types=[]
    tin_values=[]

    # for i in range():
    for i in range(len(new_json_file)):
        negotiation_arrangements.append(json_file['in_network'][i]['negotiation_arrangement'])
        names.append(json_file['in_network'][i]['name'])
        billing_code_types.append(json_file['in_network'][i]['billing_code_type'])
        billing_code_type_versions.append(json_file['in_network'][i]['billing_code_type_version'])
        billing_codes.append(json_file['in_network'][i]['billing_code'])
        descriptions.append(json_file['in_network'][i]['description'])
        # for the nested json columns
        nested_coln=json_file['in_network'][i]['negotiated_rates']
        dict_coln=nested_coln[0]
        negotiated_rates.append(dict_coln['negotiated_prices'][0]['negotiated_rate'])
        # service_codes.append(dict_coln['negotiated_prices'][0]['service_code'])
        expiration_dates.append(dict_coln['negotiated_prices'][0]['expiration_date'])
        negotiated_types.append(dict_coln['negotiated_prices'][0]['negotiated_type'])
        billing_classes.append(dict_coln['negotiated_prices'][0]['billing_class'])
        # billing_code_modifiers.append(dict_coln['negotiated_prices'][0]['billing_code_modifier'])
        # additional_informations.append(dict_coln['negotiated_prices'][0]['additional_information'])
        # if len(dict_coln['provider_groups'][0]['npi'])==1:
        #     npi = str(dict_coln['provider_groups'][0]['npi'][0])
        #     npis.append(npi)
        # if len(dict_coln['provider_groups'][0]['npi'])==2:
        #     npi = str(dict_coln['provider_groups'][0]['npi'][0])+","+str(dict_coln['provider_groups'][0]['npi'][1])
        #     npis.append(npi)
        tin=dict_coln['provider_groups'][0]['tin']
        tin_types.append(tin['type'])
        tin_values.append(tin['value']) 

    # Appending the correct values
    new_json_file['negotiation_arrangement']=negotiation_arrangements
    new_json_file['name']=names
    new_json_file['billing_code_types']=billing_code_types
    new_json_file['billing_code_type_version']=billing_code_type_versions
    new_json_file['billing_code']=billing_codes
    new_json_file['description']=descriptions
    new_json_file['negotaited_rate']=negotiated_rates
    # new_json_file['service_code']=service_codes
    new_json_file['expiration_date']=expiration_dates
    new_json_file['negotiated_type']=negotiated_types
    new_json_file['billing_class']=billing_classes
    # new_json_file['billing_code_modifier']=billing_code_modifiers
    # new_json_file['additional_information']=additional_informations
    # new_json_file['npi']=npis
    new_json_file['tin_type']=tin_types
    new_json_file['tin_value']=tin_values

    # Saving to csv
    #.to_csv(")
    new_json_file.to_csv("csv/"+file[:-4]+'csv',sep=';',index=False)
    print("Done with convert_json_to_csv()\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++\n")


if __name__ == "__main__":
    print(f"Run from command line as:\n"
          f"python3 json_to_csv.py")
    for file in os.listdir("./"):
        file_path=os.path.join("./",file)
        file_size=os.path.getsize(file_path)
        if file.endswith('.json') and file_size<=2e8:
            try:
                convert_json_to_csv(file)
                print(f"Conversion Done...\n DELETING the .json file\n{file} DELETED..!")
                os.remove(file)
            except:
                print("Fail to convert the .json file; Not deleted. Check for manual conversion")
        else:
            print(f"File size is too big {file_size/1e6} MBs")
            if file.endswith('csv') or file.endswith(".py") or file.endswith(".json") or file.endswith(".ipynb"):
                print(f"NOT DELETED => {file}\n")                
            else:
                os.remove(file)
                print(f"File is not convertible\nDELETEING this file \n{file} DELETED..!")
